open OUnit2
open Interp4

(* A few test cases *)
let tests = [
  "int"  >:: (fun _ -> assert_equal (VInt 22) (interp (Int 22)));
  "add"  >:: (fun _ -> assert_equal (VInt 22) (interp (Add(Int 11,Int 11))));
  "adds" >:: (fun _ -> assert_equal (VInt 22) (interp (Add(Add(Int 10, Int 1),Add(Int 5, Int 6)))));
  "addb" >:: (fun _ -> assert_raises (Failure "Cannot add non-integer") (fun () -> interp (Add(Int 11,Fun("x", Var "x")))));
  "let"  >:: (fun _ -> assert_equal (VInt 22) (interp (Let("x",Int 22,Var "x"))));
  "lets" >:: (fun _ -> assert_equal (VInt 22) (interp (Let("x",Int 0,Let("x",Int 22,Var "x")))));
  "varb" >:: (fun _ -> assert_raises (Failure "Unbound variable") (fun () -> interp (Var "x")));
  "fun"  >:: (fun _ -> assert_equal (VClosure ("x", Var "x", [])) (interp (Fun ("x", Var "x"))));
  "lfun" >:: (fun _ -> assert_equal (VClosure ("x", Var "x", ["y",VInt 2])) (interp (Let ("y", Int 2, Fun ("x", Var "x")))));
  "app"  >:: (fun _ -> assert_equal (VInt 22) (interp (App (Fun ("x", Add(Var "x", Int 1)), Int 21))));
  "appb" >:: (fun _ -> assert_raises (Failure "Cannot apply non-function") (fun () -> interp (App (Int 21, Int 21))));
  "scope" >:: (fun _ -> assert_equal (VInt 1)
                  (interp (Let("x", Int 1,
                               Let ("f", Fun ("y", Var "x"),
                                         Let ("x", Int 2,
                                              App(Var "f", Int 0)))))));
]

let _ = run_test_tt_main ("interp4 suite" >::: tests)
